// Quigs Symbos G9K Application
// Name:
// Coder:
// Date / Version:

// Declare variables


Var mySheet:Sheet
Var pattCount:Int
Var f:Byte
Var g:Byte

Var scrollx:Int
Var scrollxlast:Int
Var scrollxnow:Int


// End declares

Function Initialize:Void()
	// Initialize G9K App
	
	pattCount=Fore.Pattern.Load(App.Path+"sheet1.qpt",0,0)
	
	VWait
	
	For f=0 To 32 Step 2
		Meta.Int.Set f,0
	Next
	For f=0 To 32 Step 2
		Meta.Int.Set f+32,10
	Next
	For f=0 To 32 Step 2
		Meta.Int.Set f+64,2
	Next
	
	
	
	For f=0 To 15
		For g=0 To 15
			Fore.Map.Meta f,g,0
		Next
	Next
	
	scrollxlast = Shr5(scrollx)
	
EndF

Function Main:Void()
	// Main Game Loop
	
	Fore.Scroll scrollx,0
	g=Mouse.Key()
	If g=0 Then
		scrollx=Min(scrollx+1,1024)
	EndIf
	If g=1 Then
		scrollx=Max(scrollx-1,0)
	EndIf
	scrollxnow = Shr5(scrollx)
	
	If scrollxnow<>scrollxlast Then
		
		If scrollxlast>scrollxnow Then
			f=scrollxnow-2
		Else
			f=scrollxnow+10
		EndIf
		scrollxlast = scrollxnow
		Randomize f*64
		BackColour.Set 9
		Fore.Map.Meta f,0,Rnd(3)*32
		BackColour.Set 10
		Fore.Map.Meta f,1,Rnd(3)*32
		BackColour.Set 1
		Fore.Map.Meta f,2,Rnd(3)*32
		BackColour.Set 3
		Fore.Map.Meta f,3,Rnd(3)*32
		BackColour.Set 9
		Fore.Map.Meta f,4,Rnd(3)*32
		BackColour.Set 8
		Fore.Map.Meta f,5,Rnd(3)*32
		BackColour.Set 7
		Fore.Map.Meta f,6,Rnd(3)*32
		BackColour.Set 6
		Fore.Map.Meta f,7,Rnd(3)*32
		BackColour.Set 0
	EndIf
	If g=2 Then
		App.Exit
	EndIf
	
EndF



